com.holonplatform.core.property

## Interface PropertyBoxProperty

- All Superinterfaces:
    CloneableProperty<PropertyBox,PathProperty<PropertyBox>,PathProperty.Builder<PropertyBox,PathProperty<PropertyBox>,?>>, CloneableProperty.CloneablePathProperty<PropertyBox,PathProperty<PropertyBox>>, ConverterExpression<PropertyBox>, DataMappable, Expression, HasConfiguration<PropertyConfiguration>, Localizable, Path<PropertyBox>, PathExpression<PropertyBox>, PathProperty<PropertyBox>, Property<PropertyBox>, QueryExpression<PropertyBox>, QueryProjection<PropertyBox>, Serializable, TypedExpression<PropertyBox>, Validator.Validatable<PropertyBox>
  All Known Subinterfaces:
    PropertyBoxProperty.PropertyBoxPropertyBuilder

      public interface PropertyBoxProperty
      extends PathProperty<PropertyBox>

  A `PropertyBox` type `PathProperty`.

  The `PropertySet` of the `PropertyBox` type is provided at construction time and made available through the `getPropertySet()` method.

  Since:
    5.1.0

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Interface and Description
    --- | ---
    `static interface` | `PropertyBoxProperty.PropertyBoxPropertyBuilder` `PropertyBoxProperty` builder.

    - ### Nested classes/interfaces inherited from interface com.holonplatform.core.property.PathProperty

      `PathProperty.Builder<T,P extends Path<T> & Property<T>,B extends PathProperty.Builder<T,P,B>>, PathProperty.PathPropertyBuilder<T>`

    - ### Nested classes/interfaces inherited from interface com.holonplatform.core.property.CloneableProperty

      `CloneableProperty.CloneablePathProperty<T,P extends Property<T> & Path<T>>`

    - ### Nested classes/interfaces inherited from interface com.holonplatform.core.property.Property

      `Property.PropertyAccessException, Property.PropertyNotFoundException, Property.PropertyReadException, Property.PropertyReadOnlyException, Property.PropertyWriteException`

    - ### Nested classes/interfaces inherited from interface com.holonplatform.core.i18n.Localizable

      `Localizable.LocalizableBuilder, Localizable.LocalizationException`

    - ### Nested classes/interfaces inherited from interface com.holonplatform.core.Expression

      `Expression.ExpressionResolverFunction<E extends Expression,R extends Expression>, Expression.InvalidExpressionException`

    - ### Nested classes/interfaces inherited from interface com.holonplatform.core.Path

      `Path.FinalPath<T>, Path.PathBuilder<T>`

  - ### Field Summary

    - ### Fields inherited from interface com.holonplatform.core.Path

      `PATH_HIERARCHY_SEPARATOR`

    - ### Fields inherited from interface com.holonplatform.core.DataMappable

      `DEFAULT_CONFIG_PROPERTY_PREFIX, PATH`

  - ### Method Summary

    All Methods Static Methods Instance Methods Abstract Methods Default Methods
    Modifier and Type | Method and Description
    --- | ---
    `PropertyBoxProperty` | `clone(Consumer<PathProperty.Builder<PropertyBox,PathProperty<PropertyBox>,?>> builder)` Clone this property.
    `static <P extends Property> PropertyBoxProperty.PropertyBoxPropertyBuilder` | `create(String name, Iterable<P> properties)` Create a new `PropertyBoxProperty` with given `name` and bound to given `properties` property set.
    `static <P extends Property> PropertyBoxProperty.PropertyBoxPropertyBuilder` | `create(String name, P... properties)` Create a new `PropertyBoxProperty` with given `name` and bound to given `properties` property set.
    `PropertySet<?>` | `getPropertySet()` Get the `PropertySet` bound to the `PropertyBox` type of this property.

    - ### Methods inherited from interface com.holonplatform.core.property.PathProperty

      `create, create, isReadOnly`

    - ### Methods inherited from interface com.holonplatform.core.property.Property

      `getConfiguration, getConvertedValue, getConverter, getExpressionValueConverter, getName, getTemporalType, getType, present, render, renderIfAvailable`

    - ### Methods inherited from interface com.holonplatform.core.Validator.Validatable

      `getValidators, validate`

    - ### Methods inherited from interface com.holonplatform.core.i18n.Localizable

      `builder, getMessage, getMessageArguments, getMessageCode, of, of`

    - ### Methods inherited from interface com.holonplatform.core.HasConfiguration

      `hasConfiguration`

    - ### Methods inherited from interface com.holonplatform.core.ConverterExpression

      `getModelType, getModelValue`

    - ### Methods inherited from interface com.holonplatform.core.TypedExpression

      `isCollectionExpression, isConverterExpression`

    - ### Methods inherited from interface com.holonplatform.core.Expression

      `validate`

    - ### Methods inherited from interface com.holonplatform.core.query.PathExpression

      `asc, desc, from`

    - ### Methods inherited from interface com.holonplatform.core.Path

      `fullName, fullName, getName, getParent, isRootPath, of, relativeName, relativeName, stream`

    - ### Methods inherited from interface com.holonplatform.core.DataMappable

      `getDataPath, isDataMappable`

    - ### Methods inherited from interface com.holonplatform.core.query.QueryExpression

      `between, count, eq, eq, goe, goe, gt, gt, in, in, in, isNotNull, isNull, loe, loe, lt, lt, max, min, neq, neq, nin, nin, nin`

    - ### Methods inherited from interface com.holonplatform.core.query.QueryProjection

      `bean, constant, countAll, path, propertySet, propertySet`

- - ### Method Detail

    - #### clone

          PropertyBoxProperty clone(Consumer<PathProperty.Builder<PropertyBox,PathProperty<PropertyBox>,?>> builder)

      Clone this property.
      Specified by:
        `clone` in interface `CloneableProperty<PropertyBox,PathProperty<PropertyBox>,PathProperty.Builder<PropertyBox,PathProperty<PropertyBox>,?>>`
      Parameters:
        `builder` - A property builder which can be used to perform additional property configuration
      Returns:
        The cloned property

    - #### getPropertySet

          PropertySet<?> getPropertySet()

      Get the `PropertySet` bound to the `PropertyBox` type of this property.
      Returns:
        The property `PropertySet` (should never be null)

    - #### create

          static <P extends Property> PropertyBoxProperty.PropertyBoxPropertyBuilder create(String name,
                                                                                            Iterable<P> properties)

      Create a new `PropertyBoxProperty` with given `name` and bound to given `properties` property set.
      Type Parameters:
        `P` - Property set property type
      Parameters:
        `name` - Property name (not null)
        `properties` - Property set (not null)
      Returns:
        `PropertyBoxProperty` builder

    - #### create

          @SafeVarargs
          static <P extends Property> PropertyBoxProperty.PropertyBoxPropertyBuilder create(String name,
                                                                                                          P... properties)

      Create a new `PropertyBoxProperty` with given `name` and bound to given `properties` property set.
      Type Parameters:
        `P` - Property set property type
      Parameters:
        `name` - Property name (not null)
        `properties` - Property set (not null)
      Returns:
        `PropertyBoxProperty` builder

Copyright © 2019 The Holon Platform. All rights reserved.